//未渲染按钮的集合
var iconClsList = new Array();
//相当于 var iconClsList=[];

/**
 * @author 罗绍泽
 * 
 * @requires jQuery,EasyUI
 * 
 * 防止panel/window/dialog组件超出浏览器边界
 * @param left
 * @param top
 */
var easyuiPanelOnMove = function(left, top) {
	var l = left;
	var t = top;
	if (l < 1) {
		l = 1;
	}
	if (t < 1) {
		t = 1;
	}
	var width = parseInt($(this).parent().css('width')) + 14;
	var height = parseInt($(this).parent().css('height')) + 14;
	var right = l + width;
	var buttom = t + height;
	var browserWidth = $(window).width();
	var browserHeight = $(window).height();
	if (right > browserWidth) {
		l = browserWidth - width;
	}
	if (buttom > browserHeight) {
		t = browserHeight - height;
	}
	$(this).parent().css({ /* 修正面板位置 */
		left : l,
		top : t
	});
};
$.fn.dialog.defaults.onMove = easyuiPanelOnMove;
$.fn.window.defaults.onMove = easyuiPanelOnMove;
$.fn.panel.defaults.onMove = easyuiPanelOnMove;


/**
 * 
 * @requires jQuery,EasyUI
 * 
 * @param options
 *
 * 
 */
dialog = function(options) {
	var opts = $.extend({
		modal : true,
		shadow : false,
		onClose : function() {
			$(this).dialog('destroy');
		}
	}, options);
	
	opts.onLoad=function(){
		if (typeof options.onLoad == 'function') {
			options.onLoad.call();
		}
	$.messager.defaults.onClose = function() {};

		//$.messager.progress('close')
	};
	
	opts.onOpen=function(){
		if (typeof options.onOpen == 'function') {
			options.onOpen.call();
		}
	};
	return $('<div/>').dialog(opts);
};

datagrid = function(options) {
	var opts = $.extend({
		pagination : true,
		checkOnSelect : true,
		selectOnCheck : true,
		rownumbers : true,
		tableId : options.tableId,
		fitColumns:true, 
		scrollbarSize:0
	}, options);
	opts.onLoadSuccess = function(data) {
		if (typeof options.onLoadSuccess == 'function') {
			options.onLoadSuccess.call();
		}
		renderingIconClsList();
		var checkedIds = data.checkedIds;
		if(!isEmpty(checkedIds)&&checkedIds.length>0){
			var rows = data.rows;
			for (var i = 0; i < rows.length; i++) {
				for (var j = 0; j < checkedIds.length; j++) {
					if (checkedIds[j] == rows[i].id) {
						$("#"+opts.tableId).datagrid("checkRow", i);
					}
				}
			}
		}
	}
	return $('#' + opts.tableId).datagrid(opts);
}

tree = function(options) {
	var opts = $.extend({
		checkbox : true,
		lines : true,
		animate : true,
		treeId : options.treeId,
		loader : function(param, success, error) {
			$.ajax({
				url : options.url,
				data : options.params,
				dataType : 'json',
				success : function(data) {
					success(data);
				}
			});
		}
	}, options);
	return $('#' + opts.treeId).tree(opts);
}

treegrid = function(options) {
	var opts = $.extend({
		animate : true,
		rownumbers : true,
		idField : 'id',
		treeField : 'text',
		treeId : options.treeId,
		fitColumns:true, 
		scrollbarSize:0
	}, options);
	opts.onLoadSuccess = function() {
		if (typeof options.onLoadSuccess == 'function') {
			options.onLoadSuccess.call();
		}
		renderingIconClsList();
	};
	opts.onDblClickRow=function(row){
		if (typeof options.onDblClickRow == 'function') {
			options.onDblClickRow.call();
		}
		$('#' + opts.treeId).treegrid('toggle',row.id);
	};
	
	opts.onLoadError=function(){
		if (typeof options.onLoadError == 'function') {
			options.onLoadError.call();
		}
		easyui_show('数据获取失败!');
	}

	return $('#' + opts.treeId).treegrid(opts);
}

/**
 * easyui的from组件的submit方法封装
 * options={
 * 		id:'',
 *      url:'',
 *      success:function(data){
 *      
 *      }
 * }
 */
easy_form = function(options) {
	$('#' + options.id).form('submit', {
		url : ctx + options.url,
		success : function(data) {
			data = JSON.parse(data);
			data.data = JSON.parse(data.data);
			if (data.code == '0000') {
				var custom_success = options.success;
				custom_success(data);
				//不点击保存按钮时会在1秒钟后消失
				//setTimeout("$('.panel.window.panel-htop.messager-window,.window-mask,.window-shadow').hide()", 1000);
			} else {
				var custom_error = options.error;
				custom_error(data);
				//不点击保存按钮时会在1秒钟后消失
				//setTimeout("$('.panel.window.panel-htop.messager-window,.window-mask,.window-shadow').hide()", 1000);
			}
		}
	});
};

/**
 * 构建操作按钮
 */
function make_opt_btn(text, envent, row, iconCls) {
	var id = uuid();
	var btn = $("<a id=" + id + "></a>");
	btn.attr('href', '#');
	var click = envent + "('{0}');event.stopPropagation();";
	click = fs(click, JSON.stringify(row));
	btn.attr('onclick', click);
	btn.css('marginRight', '5px');
	btn.html(text);

	//添加到未渲染按钮的集合
	if (!isEmpty(iconCls)) {
		iconClsList.push({
			id : id,
			iconCls : iconCls
		});
	}
	return btn[0].outerHTML;
}

/**
 * 渲染未渲染按钮的集合中的按钮
 */
function renderingIconClsList() {
	while (iconClsList.length > 0) {
		for (index in iconClsList) {
			var iconCls = iconClsList[index];
			$("#" + iconCls.id).linkbutton({
				iconCls : iconCls.iconCls
			});
			iconClsList.splice(0, 1);
			break;
		}
	}
}


/**
 * 自定义jquery函数，完成将form 数据转换为 json格式
 */
$.fn.serializeJson = function() {
	var serializeObj = {}; // 目标对象 
	var array = this.serializeArray(); // 转换数组格式 
	// var str=this.serialize(); 
	$(array).each(function() { // 遍历数组的每个元素 {name : xx , value : xxx} 
		if (serializeObj[this.name]) { // 判断对象中是否已经存在 name，如果存在name 
			if ($.isArray(serializeObj[this.name])) {
				serializeObj[this.name].push(this.value); // 追加一个值 hobby : ['音乐','体育'] 
			} else {
				// 将元素变为 数组 ，hobby : ['音乐','体育'] 
				serializeObj[this.name] = [ serializeObj[this.name], this.value ];
			}
		} else {
			serializeObj[this.name] = this.value; // 如果元素name不存在，添加一个属性 name:value 
		}
	});
	return serializeObj;
};

/**
 * 提示信息均使用该方法
 * msg--提示信息
 * title--提示语
 */
function easyui_show(msg, title) {
	if (isEmpty(title)) {
		title = '提示';
	}
	$.messager.show({
		title : title,
		msg : msg,
		showType : 'slide',
		onOpen : function() {},
		onClose : function() {}
	});
}


//表单验证的扩展
$.extend($.fn.validatebox.defaults.rules, {
	// 验证数字
	numberCheckSub : {
		validator : function(value) {
			return /^[0-9]+$/.test(value);
		},
		message : "只能输入数字"
	}
});

function dialog_loading(id){
	$("#"+id).dialog('body').find('form').hide();
	$("#"+id).dialog('body').append($("<div class=\"panel-loading\"></div>").html('londing...'));
}

function dialog_loading_close(id){
	$("#"+id).dialog('body').find('form').show();
	$("#"+id).dialog('body').find('form').next().remove();
}

$(function() {
	$.messager.defaults = {
		ok : '确定',
		cancel : '取消',
		width : 300,
		modal : true
	};
});