/**
 * 
 * 用于表单验证
 * 扩展validatebox
 * 
 */
$.extend($.fn.validatebox.defaults.rules, {
	eqPwd : {
		validator : function(value, param) {
			return value == $(param[0]).val();
		},
		message : '密码不一致！'
	},
	//validType="sameValue['/role/rolename','role','用户名已存在']"
	sameValue : {
		validator : function(value, param,username) {
			var isSame=true;
			eval('var data={'+param[1]+':value}');
			data.id=param[3];
			$.ajax({
				url :ctx+ param[0],
				data : data,
				async : false,
				dataType:'json',
				success : function(r) {
					if (r.code=='0000') {
						isSame=r.data;
					} else {
						$.messager.show({
							title : '提示',
							msg : '验证过程出现错误！'
						});
					}
				}

			});
			return !isSame;
		},			
		message : "{2}" 	
	},
	doubleNum : {
		validator : function(value, param) {
			var r = /^\d+(?:\.\d{1,2})?$/;
			return r.test(value);
		},
		message : '请输入有效数值（小数点后最多为2位）！'
	},
	minLength : {
		validator : function(value, param) { // value 为需要校验的输入框的值 , param为使用此规则时存入的参数
			return value.length >= param[0];
		},
		message : '请输入最小{0}位字符.'
	},
	maxLength : {
		validator : function(value, param) {
			return param[0] >= value.length;
		},
		message : '请输入最大{0}位字符.'
	},
	telephone : {
		validator : function(value, param) {
			var r = /^((13[0-9])|(147)|(145)|(177)(15[0-3,5-6,7-9])|(178)|(176)|(18\d))\d{8}$/;
			return r.test(value);
		},
		message : '请输入正确的手机号码格式。'
	},
	username:{
		validator : function(value, param) {
			var r=/^[a-zA-Z]{1}[a-zA-Z\d]{3,15}/;
			return r.test(value)
		},
		message:'由英文字母和数字组成的4-16位字符,以字母开头。'
	},
	notEmpty : { // 非空字符串验证。 easyui 原装required 不能验证空格  
                validator : function(value, param) {  
                    return $.trim(value).length>0;  
                },   
                message : '该输入项为必输项'  
            },  
    integer : {// 验证整数  
                validator : function(value) {  
                    return /^[+]?[0-9]+\d*$/i.test(value);  
                },  
                message : '请输入整数'  
            },            
	english : {// 验证英语  
	            validator : function(value) {  
	                return /^[A-Za-z]+$/i.test(value);  
	            },  
	            message : '请输入英文'  
	        },  
  	// 验证电话号码    
    phone : {  
        validator : function(value) {  
            return /^((\d2,3)|(\d{3}\-))?(0\d2,3|0\d{2,3}-)?[1-9]\d{6,7}(\-\d{1,4})?$/i  
                    .test(value);  
        },  
        message : '格式不正确,请使用下面格式:020-88888888'  
    },
    // 验证是否包含空格和非法字符    
    unnormal : {  
        validator : function(value) {  
            return /.+/i.test(value);  
        },  
        message : '输入值不能为空和包含其他非法字符'  
    },
    // 验证身份证    
    idcard : {  
        validator : function(num) {  
            num = num.toUpperCase();  
            //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X。  
            if (!(/(^\d{15}$)|(^\d{17}([0-9]|X)$)/.test(num))) {  
                return false;  
            }  
            //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。  
            //下面分别分析出生日期和校验位  
            var len, re;  
            len = num.length;  
            if (len == 15) {  
                re = new RegExp(  
                        /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/);  
                var arrSplit = num.match(re);  

                //检查生日日期是否正确  
                var dtmBirth = new Date('19' + arrSplit[2]  
                        + '/' + arrSplit[3] + '/' + arrSplit[4]);  
                var bGoodDay;  
                bGoodDay = (dtmBirth.getYear() == Number(arrSplit[2]))  
                        && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3]))  
                        && (dtmBirth.getDate() == Number(arrSplit[4]));  
                if (!bGoodDay) {  
                    return false;  
                } else {  
                    //将15位身份证转成18位  
                    //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。  
                    var arrInt = new Array(7, 9, 10, 5, 8, 4,  
                            2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);  
                    var arrCh = new Array('1', '0', 'X', '9',  
                            '8', '7', '6', '5', '4', '3', '2');  
                    var nTemp = 0, i;  
                    num = num.substr(0, 6) + '19'  
                            + num.substr(6, num.length - 6);  
                    for (i = 0; i < 17; i++) {  
                        nTemp += num.substr(i, 1) * arrInt[i];  
                    }  
                    num += arrCh[nTemp % 11];  
                    return true;  
                }  
            }  
            if (len == 18) {  
                re = new RegExp(  
                        /^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/);  
                var arrSplit = num.match(re);  

                //检查生日日期是否正确  
                var dtmBirth = new Date(arrSplit[2] + "/"  
                        + arrSplit[3] + "/" + arrSplit[4]);  
                var bGoodDay;  
                bGoodDay = (dtmBirth.getFullYear() == Number(arrSplit[2]))  
                        && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3]))  
                        && (dtmBirth.getDate() == Number(arrSplit[4]));  
                if (!bGoodDay) {  
                    return false;  
                } else {  
                    //检验18位身份证的校验码是否正确。  
                    //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。  
                    var valnum;  
                    var arrInt = new Array(7, 9, 10, 5, 8, 4,  
                            2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);  
                    var arrCh = new Array('1', '0', 'X', '9',  
                            '8', '7', '6', '5', '4', '3', '2');  
                    var nTemp = 0, i;  
                    for (i = 0; i < 17; i++) {  
                        nTemp += num.substr(i, 1) * arrInt[i];  
                    }  
                    valnum = arrCh[nTemp % 11];  
                    if (valnum != num.substr(17, 1)) {  
                        return false;  
                    }  
                    return true;  
                }  
            }  
            return false;  
        },  
        message : '身份证号码格式不正确'  
    },
    checkFolderName : {
        validator : function(value, param) {
            if (value == "" || value == null) {
                return true;
            }

            var result = value == $(param[0]).val();
            //
            return !result;
        },
        message : '父节点不能选择自己'
    }
});